import { ILifetime } from '../Lifetime';
import { ScopedContext } from '../ServiceProvider';
export declare type Key<E> = keyof E & (string);
export declare type LifetimeCollection<E = any> = {
    [key in keyof E]: ILifetime<unknown, E>;
};
export declare type MatchingProperties<T, E> = {
    [K in keyof E]: E[K] extends T ? K : never;
}[keyof E];
export declare type SelectorOptions<T = any, E = any> = {
    [key in MatchingProperties<T, E>]: key & Key<E>;
};
export declare type Selector<T, E, KE = any> = (keyof KE & Key<E>) | ((e: SelectorOptions<T, E>) => (keyof KE & Key<E>));
export declare type Stateful<P, T> = {
    create(props: P): T;
};
export declare type StatefulDependencyOptions<T, P, E, KE> = {
    factory: StatefulFactory<T, P, E, KE>;
} | StatefulDependencyConstructor<T, P, E, KE>;
export declare type StatefulDependencyConstructor<T, P, E, KE> = {
    new (provider: E & KE, props: P): T;
} | {
    new (provider: E & KE): T;
} | {
    new (): T;
};
export declare type StatefulFactory<T, P, E, KE> = (provider: E & KE, props: P, scope: ScopedContext<E>) => T;
export declare type DependencyOptions<T, E> = {
    factory: Factory<T, E>;
} | DependencyConstructor<T, E>;
export declare type DependencyConstructor<T, E> = {
    new (provider: E): T;
} | {
    new (): T;
};
export declare type Factory<T, E> = (provider: E, scope: ScopedContext<E>) => T;
export declare type LifetimeConstructor<T = any, E = any> = new (name: Key<E>, factory: Factory<T, E>) => ILifetime<T, E>;
